=== debian/changelog ===
ros-foxy-depthai (2.21.2-1focal) focal; urgency=high

  * UPDATE: Use v2.21.2 due to issues this version carries
  * Contributors: Alex Bougdan, Szabolcs Gergely, Martin Peterlin

 -- Sachin Guruswamy <sachin@luxonis.com>  Wed, 05 Apr 2023 07:00:00 -0000

ros-foxy-depthai (2.21.0-1focal) focal; urgency=high

  * Improved x/y accuracy for SpatialLocationCalculator/SpatialDetectionNetwork
  * Support for median and mode, default changed to median in SpatialLocationCalculator/SpatialDetectionNetwork
  * Multi stereo support, ability to run stereo between any 2 calibrated cameras
  * Support for LEFT/RIGHT alignment in stereo node
  * Support to invalidate edge pixels: setNumInvalidateEdgePixels in Stereo Node
  * BrightnessFilter - If the input frame pixel is too dark or too bright, the disparity will be invalidated. Default pixels with value 0 are invalidated in Stereo Node
  * Added disparityToDepthUseSpecTranslation, rectificationUseSpecTranslation, and depthAlignmentUseSpecTranslation options for advanced usage in Stereo Node
  * Fix for RGB-depth alignment when RGB is configured to 12 MP
  * Crash dump support - support to retrieve crash context from the device which can be shared with developers
  * Configurable 3A fps - setIsp3aFps
  * IMU - support to retrieve connected IMU type, and firmware version. Refactored firmware update API
  * BMI270 - enable interrupt mode, timestamps are more consistent now
  * BNO086* - fix for sequence number
  * AR0234 improved AE smoothness, increased max gain to 400x (first 25.6x analog),
  * OV9782 on RGB/CAM-A socket max FPS: 120 (previously was only for OV9282), also improves image quality in very bright light,
  * OV9782/9282 minimum exposure time decreased: 20us -> 10us, helps in very bright light. TODO update tuning to make use of it, currently only possible to use with manual exposure
  * HW sync (trigger mode) enabled for OAK-D-LR, for cameras with matching FPS
  * FW: fix for UART0 / '/dev/ttyS0' init failure in Script node
  * POE power cycle fix - in rare occasions POE devices got stuck after reboot, requiring a manual power cycle
  * [XLink] Increased max number of links from 32 to 64
  * Update FW with performance metrics when DEPTHAI_LEVEL=info is enabled
  * Handle EEPROM boardOptions bit 7 for separate I2C on L/R cameras
  * Contributors: Alex Bougdan, Szabolcs Gergely, Martin Peterlin

 -- Sachin Guruswamy <sachin@luxonis.com>  Mon, 03 Apr 2023 07:00:00 -0000

ros-foxy-depthai (2.20.2-1focal) focal; urgency=high

  * Fix for ColorCamera at high resolution while using isp scaling
  * Fix for OV9282 SW sync on devices with OV9782 RGB camera
  * Fix for IMX378/477/577 on sockets other than CAM_A (RGB)
  * Contributors: Alex Bougdan, Szabolcs Gergely, Martin Peterlin

 -- Sachin Guruswamy <sachin@luxonis.com>  Tue, 31 Jan 2023 08:00:00 -0000

ros-foxy-depthai (2.20.1-1focal) focal; urgency=high

  * Modified OpenVINO::VERSION_UNIVERSAL API improvements / backward compatibility
  * Bootloader version 0.0.24 (fixes for standalone / flashed usecases)
  * [FW] Status LEDs on some additional devices
  * Contributors: Alex Bougdan, Szabolcs Gergely, Martin Peterlin

 -- Sachin Guruswamy <sachin@luxonis.com>  Sun, 29 Jan 2023 08:00:00 -0000

ros-foxy-depthai (2.19.1-1focal) focal; urgency=high

  * Added Device getDeviceName API
  * OAK-FFC 4P (R5M1E5) IR/Dot support
  * Additional Stability bugfixes to go along with 2.19.0 for PoE devices
  * Protected productName field in EEPROM
  * Contributors: Alex Bougdan, Szabolcs Gergely, Martin Peterlin

 -- Sachin Guruswamy <sachin@luxonis.com>  Mon, 28 Nov 2022 08:00:00 -0000

ros-foxy-depthai (2.19.0-1focal) focal; urgency=high

  * Stability improvements #616
  * isUserBootloaderSupported API
  * Device.setTimesync(true/false) convenience function to enable or disable subsequent timesyncing
  * Windows improvements with listing BOOTED devices ("udev permissions" issue)
  * Fix OV9282 as MonoCamera on RGB socket (issue was black image)
  * Fix crash under high load (regression with camera events streaming)
  * Fix YOLOv5/7 decoding in case of a single class
  * Fix image size when decimation filter is enabled
  * Fix for certain OV9782 and OV9282 permutations/configs
  * Reset Device timestamp on boot to zero
  * Reworded "No available devices" error message when there are other connected devices connected.
  * Update CI to Node16 compatible actions

 -- Sachin Guruswamy <sachin@luxonis.com>  Tue, 20 Sep 2022 07:00:00 -0000

ros-foxy-depthai (2.17.4-1focal) focal; urgency=high

  * DEPTHAI_WATCHDOG=0 bugfix (245fb57)
  * V5 Calibration flashing fix
  * FW log level bugfix (#587)
  * Updated DeviceBootloader::Config to retain existing values
  * PoE watchdog issues addressed (74b699c)
  * XLink - kernel driver detach (fixes some USB connectivity issues) (ba9bd8b)
  * Added EEPROM clear capability
  * Added missing installation of DLL files (#550)
  * Asset RPC refactor
  * Exposed Device::getAllConnectedDevices()
  * Exposed FW & BL versions
  * Contributors: Alex Bougdan, Szabolcs Gergely, Martin Peterlin

 -- Sachin Guruswamy <sachin@luxonis.com>  Tue, 20 Sep 2022 07:00:00 -0000

ros-foxy-depthai (2.17.3-1focal) focal; urgency=high

  * Updated FW - BMI270 IMU improvements
  * Added seq & timestamps for more messages
  * New boards support
  * Windows DLL improvements (install libusb dll alongside libdepthai-core.dll)
  * XLink - improved connecting directly to given IP
  * StereoDepth ImgFrame metadata w/h when decimation filter is enabled
  * Intrinsic read fix #379
  * Contributors: Alex Bougdan, Szabolcs Gergely, Martin Peterlin, Sachin Guruswamy

 -- Sachin Guruswamy <sachin@luxonis.com>  Fri, 05 Aug 2022 07:00:00 -0000

ros-foxy-depthai (2.17.0-1focal) focal; urgency=high

  * Support for new S2/Pro devices
  * FW: support for OAK-D-S2 / OAK-D-Pro using the latest board DM9098 R6M2E6
  * Handle new resolutions THE_720_P and THE_800_P for ColorCamera, applicable to OV9782 on RGB/center socket

